//----------------------------------------//
// billboard.h - header file for the billboard class
//
//----------------------------------------//

//include the d3d stuff
#include "d3d.h"

//return types
const int BILLBOARD_OK = 0;
const int BILLBOARD_BAD = 1;

//the standard 3d vertex
struct BILLBOARD_VERTEX
{
    D3DXVECTOR3 position;	//vertex position
	FLOAT tu, tv;		// The texture coordinates
};

//custom 3d vertex definition
#define D3DFVF_BILLBOARDVERTEX (D3DFVF_XYZ | D3DFVF_TEX1)

//the billboard class
class Billboard
{
public:
	//con/destructor
	Billboard();
	~Billboard();

	//variables
	LPDIRECT3DDEVICE8 Device;				//the d3d device
	LPDIRECT3DTEXTURE8 Texture;				//billboard texture
	LPDIRECT3DVERTEXBUFFER8 VertexBuffer;	//vertex buffer
	D3DXVECTOR3 Position;
	float Size;								//size of the billboard

	//functions
	int InitializeBillboard(LPDIRECT3DDEVICE8 device, LPCSTR TexFileName, 
		float size, D3DXVECTOR3 pos);
	int RenderBillboard();

};