//----------------------------------------//
// engine.h - header file for main engine functions
//
//----------------------------------------//

//ifndef it so it doesn't get included more than once
#ifndef _ENGINE_H_
#define _ENGINE_H_

//include the right stuff
#include <stdio.h>			//file i/o stuff for configuration file
#include <windows.h>
#include <mmsystem.h>
#include "resource.h"

// ****** TEMP ******

#include "d3d.h"
//#include "gui.h"
#include "font.h" 
#include "input.h"
#include "logfile.h"
#include "timer.h"
#include "enginedef.h"
#include "milkshape.h"
#include "gui.h"
#include "billboard.h"
//#include "model.h"
//#include "camera.h"
//#include "skybox.h"

//the engine class - it holds all the major classes for everything
class ENGINE
{
public:
	//the constructor and destructor
	ENGINE();
	~ENGINE();	


	//the BIG member classes
	TIMER timer;		//the timing class
	DI directinput;		//the Direct Input class
	D3D d3d;			//the big Direct 3D wrapper class
	FONT font;			//the font wrapper
	HWND hWnd;			//handle to the window - necessary for d3d and direct input

	//the variables that control what things should be displayed
	int ShowFPS;	//show the frames per second or not

	//the main gamestate variable - controls what main engine function is 
	//called
	int GameState;

	//the 3d models
	MODEL FourE3;
	MODEL Level;
	MODEL Skybox;
	MODEL Cloudbox;
	Sprite MenuSprite1;
	Sprite MenuSprite2;

	//***********
	Billboard TestBillboard1;
	Billboard TestBillboard2;
	
	//the variable for the menu subsystem
	int MenuState;

	//the main loop function that decides what engine function to call
	int MainLoop();

	//the engine functions - they call the other functions that make
	//up the program based on the state of the program

	int ReadConfigurationFile(char* ConfigFileName);	//reads the configuration file and
														//fills in the right variables

	int Initialize(HINSTANCE hInst, HWND hwnd);	//initializes the game engine

	int MainInputHandler();		//handles the input for the engine

	int RenderMainScene();	//renders the 3d scene for the main part of the game

	int RenderMainMenu();		//renders the menu system for the game

	void Shutdown();		//shuts down the engine

};

#endif //for _ENGINE_H_