//----------------------------------------//
// enginedef.h - contains all the necessary definitions for return types
//				and enums necessary for the engine and the corresponding parts
//				of the engine that need those parts
//
//----------------------------------------//


#ifndef _ENGINEDEF_H_
#define _ENGINEDEF_H_


#include "logfile.h"
#include "camera.h"



//macro for releasing things
#define SAFE_RELEASE(x) { if (x) { (x)->Release(); x = NULL; }}

//the return types for the engine object
enum ENGINERETURNTYPE 
{
	ENGINE_OK,
	ENGINE_BAD,
	ENGINE_QUIT
};


//the GameState types
enum STATE 
{
	INTRO,				//show intro movie/script
	RENDER_MAIN_MENU,	//menu state - handled by MenuState
	RENDER_MAIN_SCENE,	//main rendering state
	INGAMEMENU,			//in game menu state - eg pause, inventory...
	SHUTDOWN			//shutdown
};


//the MenuState types
enum MENUSTATE 
{
	MAINMENU,
	OPTIONS
};


//the global logfile
extern LOGFILE logfile;

//the global camera
extern CAMERA Camera;


#endif //endif for ENGINEDEF_H_