//----------------------------------------//
// font.h - header file for the font and font related
//		functions
//
//----------------------------------------//

//make sure things don't get included more than once
#ifndef _FONT_H_
#define _FONT_H_

//inlcude the necessary files
#include "D3DFont.h"

//define the right return type for the GUI classes	
const int FONT_OK	= 0;
const int FONT_BAD	= 1;

//the font class 
class FONT
{
public:
	//constructor
	FONT();

	//variables...
	CD3DFont* font;		//the font thing
	DWORD color;		//color

	//the functions
	int InitializeFont(LPDIRECT3DDEVICE8 device, int size);
	int Draw(float x, float y, char text[256]);
	void SetFontColor(int alpha, int red, int green, int blue);
	void ShutdownFont();
};


#endif //for _FONT_H_