//----------------------------------------//
// input.h - header file for input functions
//
//----------------------------------------//

//ifndef it so it doesn't get included more than once
#ifndef _INPUT_H_
#define _INPUT_H_

//include the necessary files for Direct Input
#include <dinput.h>			//main DI8
#include "logfile.h"		//logfile stuff
#include "enginedef.h"
#include "d3d.h"

//define the right return type for Direct Input	
const int INPUT_OK	= 0;
const int INPUT_BAD	= 1;
const int INPUT_FAILEDREAD = 1000;	//its 1000 so it doesn't conflict with the engine 
									//return type like it was


//tell the compiler that these have already been declared elsewhere
enum STATE;
enum MENUSTATE;

//the main Direct Input class
class DI
{
public:
	//the constructor/destructor
	DI();
	~DI();

	//the Direct Input variables
	LPDIRECTINPUT8 lpdi;				//the pointer to the DI object
	LPDIRECTINPUTDEVICE8 lpdimouse;		//input for the mouse
	DIMOUSESTATE2 mousestate;			//mouse state
	LPDIRECTINPUTDEVICE8 lpdikey;		//pointer to the DI keyboard
	char keystate[256];					//buffer for the input
	bool active;						//variable if the keyboard is active or not
	float MouseMultiplier;				//multiplied by the mouse to make it move faster
	int MouseX;	//absolute mouse x position
	int MouseY;	//absolute mouse y position

	//the Direct Input functions 
	int InitializeDirectInput(HINSTANCE hInst, HWND hWnd);
	int ShutdownDirectInput();
	
	//the main input handler - handles all input for all states
	//int MainInputHandler(int GameState);

	//keyboard functions
	int ActivateKeyboard();
	int DeActivateKeyboard();
	bool KeyDown(const int key);
	bool KeyUp(const int key);
	int ReadKeys();
	

	//mouse functions
	int ReadMouse();

};



#endif